﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>
<%@ Register TagPrefix="sds" Namespace="Telerik.Web.SessionDS" %>
<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style type="text/css">
        
    .CustomValidatorCalloutStyle div, 
    .CustomValidatorCalloutStyle td 
    { 
        border:solid 1px blue; background-color: #ADD8E6; 
    }

        
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <asp:ScriptManager ID="ScriptManager1" runat="server">
    </asp:ScriptManager>
    
    <div>
    
        <telerik:RadScriptBlock ID="RadScriptBlock1" runat="server">
            <script type="text/javascript">
                    //On insert and update buttons click temporarily disables ajax to perform upload actions
                    function conditionalPostback(e, sender)
                    {
                        var theRegexp = new RegExp("\.UpdateButton$|\.PerformInsertButton$", "ig");
                        if (sender.EventTarget.match(theRegexp))
                        {
                            var upload = $find(window['UploadId']);                  
                            //AJAX is disabled only if file is selected for upload
                            if(upload.getFileInputs()[0].value != "")
                            {
                                sender.EnableAjax = false;
                            }
                         }
                    }
            </script>
        </telerik:RadScriptBlock>
        
        <telerik:RadAjaxManager 
            ID="RadAjaxManager1" 
            runat="server"
            ClientEvents-OnRequestStart="conditionalPostback">
            <AjaxSettings>
                <telerik:AjaxSetting AjaxControlID="RadGrid1">
                    <UpdatedControls>
                        <telerik:AjaxUpdatedControl ControlID="RadGrid1" />
                    </UpdatedControls>
                </telerik:AjaxSetting>
            </AjaxSettings>
        </telerik:RadAjaxManager>
        
        <%--<telerik:RadAjaxPanel ID="RadAjaxPanel1" 
            runat="server" 
            ClientEvents-OnRequestStart="conditionalPostback">--%>
    
       <telerik:RadGrid 
            runat="server" 
            ID="RadGrid1"
            Width="97%"
            Skin="Web20" 
            AllowPaging="True" 
            AllowSorting="True"
            AutoGenerateColumns="False"  
            DataSourceID="sdsImages" 
            AllowAutomaticInserts="true"
            AllowAutomaticUpdates="true" 
            AllowAutomaticDeletes="true" 
            ShowStatusBar="True" 
            GridLines="None" 
            OnInsertCommand="RadGrid1_InsertCommand" 
            OnItemDataBound="RadGrid1_ItemDataBound" 
            OnUpdateCommand="RadGrid1_UpdateCommand">
                <PagerStyle Mode="NextPrevAndNumeric" />
                <MasterTableView 
                    Width="100%" 
                    CommandItemDisplay="Top" 
                    DataKeyNames="ID" 
                    DataSourceID="sdsImages">
                    <Columns>
                    
                        <telerik:GridEditCommandColumn>
						</telerik:GridEditCommandColumn>
						
						<telerik:GridTemplateColumn 
						    HeaderText="Image Name" 
						    UniqueName="ImageName" 
						    SortExpression="Name">
							<ItemTemplate>
								<asp:Label 
								    runat="server" 
								    ID="lblName" 
								    Text='<%# Eval("Name") %>' />
							</ItemTemplate>
							<EditItemTemplate>
								<asp:TextBox 
								    runat="server" 
								    Style="width: 
								    205px; margin-left: 3px;" 
								    ID="txbName"
									Text='<%# Bind("Name") %>' />
								<asp:RequiredFieldValidator 
								    ID="Requiredfieldvalidator1" 
								    runat="server" 
								    ControlToValidate="txbName"
									ErrorMessage="Please, enter a name!" >
								</asp:RequiredFieldValidator>
								
								<cc1:ValidatorCalloutExtender 
                                    ID="ValidatorCalloutExtender1" 
                                    runat="server"
                                    TargetControlID="Requiredfieldvalidator1" >
                                </cc1:ValidatorCalloutExtender> 
							</EditItemTemplate>
							
						</telerik:GridTemplateColumn>
                        
                        <telerik:GridButtonColumn 
                            ButtonType="LinkButton" 
                            CommandName="Delete" 
                            UniqueName="Delete" 
                            Text="Delete">
                        </telerik:GridButtonColumn>
                        
                        <telerik:GridTemplateColumn 
                            HeaderText="Description" 
                            UniqueName="Description" 
                            DataField="ImgDesc">
                            <ItemTemplate>
                                <asp:Label 
                                    ID="lblDescription" 
                                    runat="server" 
                                    Text='<%# Eval("Description") %>' />
                            </ItemTemplate>
                            
                            <%-----------AJAX validation--------------- --%>
                            <EditItemTemplate>
                                <asp:TextBox 
                                    ID="txbDescription" 
                                    Style="width: 205px; margin-left: 4px;" 
                                    runat="server"
                                    TextMode="SingleLine" 
                                    Text='<%# Bind("Description") %>' />
                                    
                                <asp:RequiredFieldValidator 
                                    ID="Requiredfieldvalidator2" 
                                    runat="server" 
                                    ControlToValidate="txbDescription"
									ErrorMessage="Please, enter a description!" >
								</asp:RequiredFieldValidator>  
								
                                <cc1:ValidatorCalloutExtender 
                                    ID="ValidatorCalloutExtender2" 
                                    runat="server"
                                    TargetControlID="Requiredfieldvalidator2"
                                     >
                                </cc1:ValidatorCalloutExtender>    
                                    
                            </EditItemTemplate>
                        </telerik:GridTemplateColumn>
                        
                        <telerik:GridTemplateColumn 
                            HeaderText="Image" 
                            UniqueName="Upload">
                            <ItemTemplate>
                                <a href="ShowImageCS.aspx?id=<%# Eval("ID") %>">
									<asp:Image 
									    runat="server" 
									    ID="ImageThumbnail" 
									    AlternateText="Click here to open the real size image"
										ImageUrl='<%# "ShowImageCS.aspx?thumbnail=true&ID=" + Eval("ID")%>' Style="border-width: 0px;" />
								</a>
                            </ItemTemplate>
                            <EditItemTemplate>
                                <telerik:RadUpload 
                                    ID="RadUpload1" 
                                    runat="server" 
                                    InitialFileInputsCount="1" 
                                    MaxFileInputsCount="1"
                                    ControlObjectsVisibility="None" 
                                    MaxFileSize="1000000" 
                                    AllowedFileExtensions=".jpg,.bmp,.gif,.dib,.jpeg,.jpe,.jfif,.png,.tif,.tiff" />
                            </EditItemTemplate>
                        </telerik:GridTemplateColumn>
                        
                    </Columns>
                    <EditFormSettings>
                        <EditColumn 
                            UniqueName="EditCommandColumn1">
                        </EditColumn>
                    </EditFormSettings>
                    <ExpandCollapseColumn>
                        <HeaderStyle 
                            Width="20px" />
                    </ExpandCollapseColumn>
                    <RowIndicatorColumn>
                        <HeaderStyle 
                            Width="20px" />
                    </RowIndicatorColumn>
            </MasterTableView>

            <FilterMenu>
            <CollapseAnimation 
                Type="OutQuint" 
                Duration="200">
            </CollapseAnimation>
            </FilterMenu>
        </telerik:RadGrid>
        
        <sds:SessionDataSource ID="sdsImages" runat="server" ConnectionString="<%$ ConnectionStrings:TelerikConnectionString %>"
			SelectCommand="SELECT * FROM [Images]"
			InsertCommand="INSERT INTO [Images] ([Name], [Description], [Data]) VALUES (@Name, @Description, @Data)"
			UpdateCommand="UPDATE [Images] SET [Name] = @Name, [Description] = @Description, [Data] = @Data WHERE [ID] = @ID"
			DeleteCommand="DELETE FROM [Images] WHERE [ID] = @ID" PrimaryKeyFields="ID" SessionKey="UploadGridCS">
			<InsertParameters>
				<asp:Parameter Name="Name" Type="String" />
				<asp:Parameter Name="Description" Type="String" />
				<asp:SessionParameter SessionField="DataCS" Name="Data" />
			</InsertParameters>
			<UpdateParameters>
				<asp:Parameter Name="Name" Type="String" />
				<asp:Parameter Name="Description" Type="String" />
				<asp:SessionParameter SessionField="DataCS" Name="Data" />
				<asp:Parameter Name="ID" Type="Int32" />
			</UpdateParameters>
			<DeleteParameters>
				<asp:Parameter Name="ID" Type="Int32" />
			</DeleteParameters>
		</sds:SessionDataSource>
		<asp:SqlDataSource ID="SqlDataSource2" runat="server" ConnectionString="<%$ ConnectionStrings:TelerikConnectionString %>"
			SelectCommand="SELECT * FROM [Authors]"></asp:SqlDataSource>
       <%-- </telerik:RadAjaxPanel>--%>
        
    </div>
    </form>
</body>
</html>



