﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.IO;
using System.Drawing;
using Telerik.Web.UI;
using System.Drawing.Imaging;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void RadGrid1_InsertCommand(object source, GridCommandEventArgs e)
    {
        Session["ImgBody"] = null;
        InitializeUpdateParameter((RadUpload)e.Item.FindControl("RadUpload1"));
    }

    protected void RadGrid1_UpdateCommand(object source, GridCommandEventArgs e)
    {
        Session["ImgBody"] = null;
        InitializeUpdateParameter((RadUpload)e.Item.FindControl("RadUpload1"));
    }

    protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridEditableItem && e.Item.IsInEditMode)
        {
            RadUpload upload = (RadUpload)e.Item.FindControl("RadUpload1");
            //RadAjaxPanel1.ResponseScripts.Add(string.Format("window['UploadId'] = '{0}';", upload.ClientID));
            RadAjaxManager1.ResponseScripts.Add(string.Format("window['UploadId'] = '{0}';", upload.ClientID));
        }
    }
  
    private void InitializeUpdateParameter(RadUpload currentUpload)
    {
        int stdWidth;
        int stdHeight;
        MemoryStream imgStream = new MemoryStream();
        Bitmap img = new Bitmap(currentUpload.UploadedFiles[0].InputStream);
        if (currentUpload.UploadedFiles.Count > 0)
        {
            if (img.Width > img.Height)
            {
                stdWidth = 500;
                stdHeight = img.Height / (img.Width / stdWidth);
            }
            else
            {
                stdHeight = 500;
                stdWidth = img.Width / (img.Height / stdHeight);
            }
            System.Drawing.Size NewSize = new System.Drawing.Size(stdWidth, stdHeight);
            Bitmap newimg = new Bitmap(img, NewSize.Width, NewSize.Height);
            newimg.Save(imgStream, ImageFormat.Jpeg);
            byte[] data = imgStream.ToArray();
            imgStream.Read(data, 0, data.Length);
            Session["ImgBody"] = data;
        }
    }


}
